/**********************************************
  Ver	    ύX
 ----------------------------------------------
  2.00	Sʉ
  2.03	sۂ̃bZ[WC
  2.10		     V
  2.14	stdlib.hctype.hincludeYĂ
  2.16	ɂႨΉ
 **********************************************/
#define INCL_DOSQUEUES
#include <os2.h>
#include <stdlib.h>
#include <stdio.h>
#include <share.h>
#include <ctype.h>
#include <string.h>
#include "misc.h"

int cdd(char*dir,const char*BatchName)
{
    int rc;
    char*cp;

    if(_chdir2(dir)){
	fprintf(stderr,"Can't change current directory to \"%s\"\n"
		       "\"%c:/DirTree.acd\" may be old.  "
		       "Try acd with \"-s%c\" parameter\n",
		dir,*dir,_tolower(*dir));
	return 1;
    }
    if(!BatchName){
	HPIPE hp;
	unsigned long u;
	char cmd[512];

	if(!(cp=getenv("PIPE2NYAOS"))){
	    fputs("Oops! Environment variable PIPE2NYAOS is not defined\n",
		  stderr);
	    return 1;
	}
	rc=DosOpen(cp,&hp,&u,0,FILE_NORMAL,
		   OPEN_ACTION_FAIL_IF_NEW|OPEN_ACTION_OPEN_IF_EXISTS,
		   OPEN_ACCESS_WRITEONLY|OPEN_SHARE_DENYNONE,NULL);
	if(rc){
	    fprintf(stderr,"DosOpen failure.  RC=%d\n",rc);
	    return 1;
	}
	sprintf(cmd,"%s \"%s\"",nyaos_cmd,dir);
	DosWrite(hp,cmd,strlen(cmd)+1,&u);
	DosClose(hp);
	return 0;
    }
    if(!(fp=_fsopen(BatchName,"wt",SH_DENYRW))){
	perror(BatchName);
	return 1;
    }
    while((cp=strchr(dir,'/'))!=NULL)
	*cp='\\';
    rc=fprintf(fp,"@%.2s\n@cd \"%s\"",dir,dir+2)==EOF;
    fclose(fp);
    if(rc)
	perror(BatchName);
    return rc;
}
